﻿BUF_AreaMT = BUF_Area:new()

function BUF_AreaMT:Create()
	local unitId, uf

	self.Name = "MT"
	self.num = 20	
	self.MaxColumns = 2
	self.MaxRows = 10
	self.MinDisplayRows = 4
	self.Targets = true
	
	for i = 1, 10 do
		uf = BUF_Factory:CreateUnitFrameStructure(self)
		
		-- Echte unitId steht noch nicht fest		
		uf.unitId = ""
		uf.vehicleId = ""

		self.frame[i] = uf
				
		-- target des Maintanks
		uf = BUF_Factory:CreateUnitFrameStructure(self)
		
		-- Echte unitId steht noch nicht fest		
		uf.unitId = ""
		uf.vehicleId = ""

		self.frame[i + 10] = uf
	end	
end


function BUF_AreaMT:UpdateMainTank()
	if InCombatLockdown() then return end
	
	local tuf
	local tankIndex = 0
	local names = {}
	local assigned = {}
	
	-- Dungeon Finder Tank rolle
	for k, v in ipairs(BUF_Roster.partyIds) do
		local role = UnitGroupRolesAssigned(v)
			
		if role == "TANK" then
			tankIndex = tankIndex + 1
				
			assigned[v] = true

			tuf = self.frame[tankIndex]
			tuf.unitId = v
			tuf.vehicleId = BUF_Roster.partyPetIds[k]				
			self.unitId[tuf.unitId] = tankIndex
			BUF_Factory:UpdateSecureButton(tuf)				
				
			tuf = self.frame[tankIndex + 10]
			tuf.unitId = v .. "target"
			tuf.vehicleId = ""
			self.unitId[tuf.unitId] = tankIndex + 10 
			BUF_Factory:UpdateSecureButton(tuf)								
		end
	end
	
	-- Blizzard Maintanks hinzufügen
	for raidIndex = 1, MAX_RAID_MEMBERS do
		local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(raidIndex)
			
		if name then
			names[name] = raidIndex
				
			if role == "MAINTANK" then
				tankIndex = tankIndex + 1
					
				assigned["raid" .. raidIndex] = true

				tuf = self.frame[tankIndex]
				tuf.unitId = "raid" .. raidIndex
				tuf.vehicleId = ""
				self.unitId[tuf.unitId] = tankIndex
				BUF_Factory:UpdateSecureButton(tuf)
					
				tuf = self.frame[tankIndex + 10]
				tuf.unitId = "raid" .. raidIndex .. "target"
				tuf.vehicleId = ""
				self.unitId[tuf.unitId] = tankIndex + 10 
				BUF_Factory:UpdateSecureButton(tuf)			
			end
		end
	end
		
	-- dann noch oRA Maintanks anfügen
	for oRAIndex = 1, 10 do
		local unitId = "raid" .. (names[BUF_Roster.oRA_mt[oRAIndex]] or "")
		if BUF_Roster.oRA_mt[oRAIndex] and names[BUF_Roster.oRA_mt[oRAIndex]] and not assigned[unitId] then
			tankIndex = tankIndex + 1	
				
			assigned[unitId] = true							
				
			tuf = self.frame[tankIndex]
			tuf.unitId = unitId
			tuf.vehicleId = ""			
			self.unitId[tuf.unitId] = tankIndex
			BUF_Factory:UpdateSecureButton(tuf)
				
			tuf = self.frame[tankIndex + 10]
			tuf.unitId = unitId .. "target"
			tuf.vehicleId = ""
			self.unitId[tuf.unitId] = tankIndex + 10 
			BUF_Factory:UpdateSecureButton(tuf)
		end
	end
		
	for removeIndex = tankIndex + 1, 10 do
		self.frame[removeIndex].unitId = ""
		self.frame[removeIndex].vehicleId = ""			
		self.frame[removeIndex + 10].unitId = ""
		self.frame[removeIndex + 10].vehicleId = ""
	end
		
	self.Active = tankIndex > 0
end