﻿BUF_AreaRaid = BUF_Area:new()

function BUF_AreaRaid:Create()
	local unitId, uf

	self.Name = "RAID"
	self.num = MAX_RAID_MEMBERS

	for i = 1, MAX_RAID_MEMBERS do
		unitId = "raid" .. i
		uf = BUF_Factory:CreateUnitFrameStructure(self)
		uf.unitId = unitId
		uf.vehicleId = "raidpet" .. i	
		uf.dropDown = FriendsDropDown
		uf.number = i

		self.frame[i] = uf
		self.unitId[unitId] = i
		self.vehicleId[uf.vehicleId] = i
	end	
end

function BUF_AreaRaid:Rearrange(initialization)
	if InCombatLockdown() and not initialization then
		self:UpdateVisibility()
		return
	end	

	local groups = {
		0, 0, 0, 0, 0, -- Gruppe 1
		0, 0, 0, 0, 0, -- Gruppe 2
		0, 0, 0, 0, 0, -- Gruppe 3
		0, 0, 0, 0, 0, -- Gruppe 4
		0, 0, 0, 0, 0, -- Gruppe 5
		0, 0, 0, 0, 0, -- Gruppe 6
		0, 0, 0, 0, 0, -- Gruppe 7
		0, 0, 0, 0, 0, -- Gruppe 8			
	}
	local nonexistant = {
		1, 2, 3, 4, 5, 6, 7, 8, 9, 10,
		11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
		21, 22, 23, 24, 25, 26, 27, 28, 29, 30,
		31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
	}
	local name, subgroup, index, firstindex
	local maxsubgroup = 0
	
	for raidIndex = 1, MAX_RAID_MEMBERS do
		name, _, subgroup = GetRaidRosterInfo(raidIndex)
			
		if name then				
			firstindex = (subgroup - 1) * 5 + 1
								
			-- letzter freier Platz in der Gruppe suchen
			index = firstindex
			while index <= MAX_RAID_MEMBERS do
				if groups[index] == 0 then break end
				index = index + 1
			end
			if index <= MAX_RAID_MEMBERS then
				groups[index] = raidIndex
				nonexistant[raidIndex] = 0
			end

			-- insert sort des neu eingefügten Namens
			while index > firstindex do
				local cmpname = UnitName("raid" .. groups[index - 1])
				if name < cmpname then
					groups[index - 1], groups[index] = groups[index], groups[index - 1]
				else
					break
				end
				index = index - 1
			end
				
			if subgroup > maxsubgroup then maxsubgroup = subgroup end
		end
	end
		
	-- nicht existierende auf freie Plätze verteilen
	index = 1
	for raidIndex = 1, MAX_RAID_MEMBERS do
		if nonexistant[raidIndex] > 0 then						
			-- freien Platz suchen
			while groups[index] ~= 0 and index <= MAX_RAID_MEMBERS do
				index = index + 1
			end
			if index <= MAX_RAID_MEMBERS then
				groups[index] = raidIndex
			end
		end
	end
	
	self:UpdatePlacement(initialization, groups, maxsubgroup)
end
