﻿BUF_AreaRaidPet = BUF_Area:new()

function BUF_AreaRaidPet:Create()
	local unitId, uf

	self.Name = "RAIDPET"
	self.num = MAX_RAID_MEMBERS
	self.MaxColumns = 2
	self.MaxRows = 10
	self.MinDisplayRows = 4
	self.MinDisplayColumns = 2
	
	for i = 1, MAX_RAID_MEMBERS do
		unitId = "raidpet" .. i	
		uf = BUF_Factory:CreateUnitFrameStructure(self)
		uf.unitId = unitId
		uf.vehicleId = ""			
		uf.number = i

		self.frame[i] = uf
		self.unitId[unitId] = i
	end	
end

function BUF_AreaRaidPet:Rearrange(initialization)
	if InCombatLockdown() and not initialization then
		self:UpdateVisibility()
		return
	end	

	local groups = {
		0, 0, 0, 0, 0, -- Gruppe 1
		0, 0, 0, 0, 0, -- Gruppe 2
		0, 0, 0, 0, 0, -- Gruppe 3
		0, 0, 0, 0, 0, -- Gruppe 4
		0, 0, 0, 0, 0, -- Gruppe 5
		0, 0, 0, 0, 0, -- Gruppe 6
		0, 0, 0, 0, 0, -- Gruppe 7
		0, 0, 0, 0, 0, -- Gruppe 8			
	}
	local nonexistant = {
		1, 2, 3, 4, 5, 6, 7, 8, 9, 10,
		11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
		21, 22, 23, 24, 25, 26, 27, 28, 29, 30,
		31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
	}

	local col = 1
	local row = 1
	local displayRows = 0
	local displayCols = 0
	local index = 0
	for i = 1, self.num do
		local uf = self.frame[i]
		if UnitExists(uf.unitId) then
			index = index + 1
			groups[index] = i
			nonexistant[i] = 0						

			displayCols = col
			displayRows = row
			row = row + 1
			if row > self.MaxRows then
				row = 1
				col = col + 1
			end
		end
	end
		
	-- nicht existierende auf freie Plätze verteilen
	for i = 1, self.num do
		if nonexistant[i] > 0 then						
			index = index + 1
			groups[index] = i
		end
	end

	self:UpdatePlacement(initialization, groups, displayRows)
end