﻿-- Buff-Bar

BBB_Factory = {
	BuffColor = {
		{ r = 1, g = 1, b = 0 },
		{ r = 0.5, g = 1, b = 1 },
		{ r = 1, g = 0, b = 1 },
		{ r = 0.5, g = 1, b = 0.5 },
	},
}

function BBB_Factory:CreateBuffBar(parent, index, template)
	local buffbar = {		
		buffindex = index,
		timestamp = 0,
		duration = 0,
		expirationTime = 0,
		tpl = template,
	}
	
	buffbar.BaseFrame = CreateFrame("Frame", nil, parent)
	buffbar.BaseFrame:Hide()

	buffbar.Background = buffbar.BaseFrame:CreateTexture()
	buffbar.Background:SetAllPoints(buffbar.BaseFrame)
	buffbar.Background:SetTexture(self.BuffColor[buffbar.buffindex].r, self.BuffColor[buffbar.buffindex].g, self.BuffColor[buffbar.buffindex].b, 0.2)
	buffbar.Background:Hide()

	buffbar.Bar = CreateFrame("StatusBar", nil, buffbar.BaseFrame, "TextStatusBar")
	buffbar.Bar:SetAllPoints(buffbar.BaseFrame)
	buffbar.Bar:SetStatusBarTexture(bUF.LSM:Fetch(bUF.LSM.MediaType.STATUSBAR, template.BarTexture))	
	buffbar.Bar:SetStatusBarColor(self.BuffColor[buffbar.buffindex].r, self.BuffColor[buffbar.buffindex].g, self.BuffColor[buffbar.buffindex].b, 1)

	buffbar.Bar:SetMinMaxValues(0, 100)
		   
    return buffbar
end

function BBB_Factory:UpdateBuffBar(buffbar, timestamp, duration, expirationTime)
	buffbar.timestamp = timestamp
	buffbar.duration = duration
	buffbar.expirationTime = expirationTime

	buffbar.BaseFrame:Show()
	buffbar.Background:Show()

	buffbar.Bar:SetMinMaxValues(0, math.max(1, duration))
		
	self:UpdateCowndown(buffbar)
end

function BBB_Factory:UpdateCowndown(buffbar)
	if (buffbar.expirationTime or 0) > 0 then
		buffbar.Bar:SetValue(buffbar.expirationTime - GetTime())
	else
		buffbar.Bar:SetValue(1)
	end
end

function BBB_Factory:HideBuffBar(buffbar)
	buffbar.timestamp = 0
	buffbar.duration = 0
	buffbar.expirationTime = 0
	
	buffbar.BaseFrame:Hide()
	buffbar.Background:Hide()
end
