﻿-- Klassendefinition für UnitFrame

local GetTime = GetTime
local pairs, ipairs = pairs, ipairs

BUF_Factory = {	
	buffCheckMode = false,

	templates = {},
	
	DebuffTypeColor = {
		["Magic"] = { r = 0.4, g = 0.4, b = 0.8 },
		["Disease"] = { r = 0.8, g = 0.4, b = 0.4 },
		["Curse"] = { r = 0.7, g = 0, b = 0.7 },
		["Poison"] = { r = 0, g = 0.592, b = 0.8 },
		["Possessed"] = { r = 0.51, g = 0.082, b = 0.263 },
	},
		
	MouseSpells = {
		["DRUID"] = {
			spell2 = 2782,  -- Verderbnis entfernen
			spell4 = 29166, -- Anregen
			spell5 = 20484, -- Wiedergeburt
		},
		["MAGE"] = {
			spell2 = 475,   -- Fluch aufheben
			spell3 = 130,   -- Langsamer Fall
			spell4 = 54646, -- Magie fokussieren
		},
		["PALADIN"] = { 
			spell2 = 4987,  -- Reinigung des Glaubens
			spell3 = 53601, -- Geheiligter Schild
			spell4 = 1038,  -- Hand der Erlösung
			spell5 = 6940,  -- Hand der Aufopferung
		},		
		["PRIEST"] = {
			spell2 = 988,	-- Magiebannung
			spell3 = 552,	-- Krankheit aufheben
			spell4 = 6346,  -- Furchtzauberschutz
			spell5 = 47788, -- Schutzgeist
		},
		["WARRIOR"] = {
			spell2 = 3411,	-- Einschreiten
			spell4 = 50720, -- Wachsamkeit
		},
	},

	MissingBuff = {
		["KINGS"] = {
			["DRUID"] = { 79061, 79060, },  -- 79060: Buff auf Spieler außerhalb der Gruppe/Raid
			["PALADIN"] = { 79063, },
		},
		["MIGHT"] = {
			["PALADIN"] = { 79102, },
		},
		["INT"] = {
			["MAGE"] = { 79058, 79038, }, -- Arcane Brilliance, Dalaran Brilliance
			["WARLOCK"] = { 54424, }, -- Fel Intelligence
		},
		["STAMINA"] = {
			["PRIEST"] = { 79105, },
			["WARRIOR"] = { 469, }, 
			["WARLOCK"] = { 6307, }, 
		},
	},
			
	BuffWhitelist = {
		[10278] = true, -- Hand of Protection
		[6940] = true,  -- Hand der Aufopferung
		[22812] = true, -- Baumrinde
		[47788] = true, -- Schutzgeist
		[871] = true,	-- Schildwall
		[12976] = true,	-- Last Stand
		[498] = true,	-- Göttlicher Schutz		
		[33206] = true, -- Schmerzunterdrückung
		-- [48066] = true, -- Machtwort: Seelenstärke
	},
	
	EmergencyDebuff = {
		[(GetSpellInfo(66870))] = true, -- Burning Bile
		[(GetSpellInfo(66823))] = true, -- Paralytic Toxin
		[(GetSpellInfo(66237))] = true, -- Incinerate Flesh
		[67574] = true, -- Pursued by Anub'arak
		[(GetSpellInfo(66013))] = true, -- Penetrating Cold
		[69065] = true, -- Impaled
		[(GetSpellInfo(72293))] = true, -- Mark of the Fallen Champion
		[70447] = true, -- Volatile Ooze Adhesive
		[70672] = true, -- Gaseous Bloat
		[(GetSpellInfo(72855))] = true, -- Unbound Plague
		[70877] = true, -- Frenzied Bloodthirst
		[71340] = true, -- Pact of the Darkfallen
		[70126] = true, -- Frost Beacon	
		[(GetSpellInfo(68980))] = true, -- Harvest Soul
		[(GetSpellInfo(70541))] = true, -- Infest
		[(GetSpellInfo(69409))] = true, -- Soul Reaper
	},
	
	-- Whitelist für Buffs, die vom Spieler gewirkt wurden
	PlayerBuffWhitelist = {
		[53601] = true, -- Geheiligter Schild
		[53563] = true, -- Flamme des Glaubens
		[66922] = true, -- Lichtblitz - HoT
		
		[48441] = true, -- Verjüngung
		[48443] = true, -- Nachwachsen
		[48447] = true, -- Gelassenheit
		[48451] = true, -- Blühendes Leben
		[53251] = true, -- Wildwuchs
		
		[48066] = true, -- Machtwort: Schild
		[48068] = true, -- Erneuerung
		[48111] = true, -- Gebet der Besserung
	},
	
	DebuffBlacklist = {
		[6788] = true, -- Weakened Soul
		[57724] = true, -- Sated
		[25771] = true, -- Forbearance
		[69127] = true, -- Chill of the Throne
		[36032] = true, -- Arcane Blast
		[41425] = true, -- Unterkühlung
		[(GetSpellInfo(23447))] = true, -- Transporter Malfunction
		[26013] = true, -- Deserter
		[71041] = true, -- Dungeon Deserter
		[36900] = true, [36901] = true, -- Soul Split: Evil / Good		
		[(GetSpellInfo(70084))] = true, -- Frost Aura
	},

	SpellWhitelist = {
		[(GetSpellInfo(72762))] = true, -- Defile
		[(GetSpellInfo(68981))] = true, -- Remorseless Winter
		[70123] = true, -- Blistering Cold
	},

	WellFedList = {
		[57327] = true, -- 40 Stamina, 46 Spell Power
		[59230] = true, -- 40 Dodge Rating
		[57399] = true, -- 80 Atp, 46 Spell Power, 40 Stamina
		[57371] = true, -- 40 Strength, 40 Stamina
		[57367] = true, -- 40 Agi, 40 Stamina
		[57365] = true, -- 40 Spirit, 40 Stamina
		[57360] = true, -- 40 Hit Rating, 40 Stamina
		[57358] = true, -- 40 Arp, 40 Stamina
		[57356] = true, -- 40 Expertise, 40 Stamina
		[57334] = true, -- 20 mp5, 40 Stamina
		[57332] = true, -- 40 Haste Rating, 40 Stamina
		[57329] = true, -- 40 Crit Rating, 40 Stamina
		[57325] = true, -- 80 Atp, 40 Stamina
	},	

	Eating = (GetSpellInfo(45548)),

	FlaskList = {
		[53755] = true, -- Spellpower flask
		[53760] = true, -- Ap flask
		[54212] = true, -- mp5 flask
		[53758] = true, -- hp flask
		[62380] = true, -- resistance flask
		[17627] = true, -- Destilled Wisdom
	},
}

function BUF_Factory:CreateTemplates()
	self:CreateTemplate("standard")
	if self.db.global.templates then
		for k, _ in pairs(self.db.global.templates) do
			if not self.templates[k] then
				self:CreateTemplate(k)
			end
		end	
	end
end

function BUF_Factory:GetTemplate(templateName)
	local r = self.templates[templateName]
	if not r then
		r = self.templates["standard"]
	end
	return r
end

function BUF_Factory:Init()
	self.DebuffBlackList = CSL_Factory:CreateSpellList(self.db.global.debuffblacklist)
	self.BuffWhiteList = CSL_Factory:CreateSpellList(self.db.global.buffwhitelist)
	self.EmergencyDebuffList = CSL_Factory:CreateSpellList(self.db.global.emergencydebuff)
	self.SpellWhiteList = CSL_Factory:CreateSpellList(self.db.global.spellwhitelist)

	local _, className = UnitClass("player")
	self.PlayerBuffWhiteList = CSL_Factory:CreateSpellList(self.db.global.buffs[className], true)
end

function BUF_Factory:PurgeSpellCache()
	CSL_Factory:ResetCache(self.DebuffBlackList)
	CSL_Factory:ResetCache(self.BuffWhiteList)
	CSL_Factory:ResetCache(self.EmergencyDebuffList)
	CSL_Factory:ResetCache(self.SpellWhiteList)
	CSL_Factory:ResetCache(self.PlayerBuffWhiteList)
end

function BUF_Factory:BuffsAssigned()
	local _, className = UnitClass("player")
	local bl = self.db.global.buffs[className]
	local num = 0

	if bl.buff1 then num = num + 1 end
	if bl.buff2 then num = num + 1 end
	if bl.buff3 then num = num + 1 end
	if bl.buff4 then num = num + 1 end
	return num
end

function BUF_Factory:UpdateDisplayUnitId(uf)
	if uf and uf.unitId then
		if UnitControllingVehicle(uf.unitId) and uf.vehicleId and uf.vehicleId ~= "" and UnitExists(uf.vehicleId) then
			uf.displayUnitId = uf.vehicleId
		else
			uf.displayUnitId = uf.unitId
		end
	end
end

function BUF_Factory:GetDisplayUnitId(uf)	
	if uf and uf.guiCreated and uf.displayUnitId and UnitExists(uf.displayUnitId) then
		return uf.displayUnitId			
	end
end

function BUF_Factory:CreateTemplate(templateName)
	local tpl = {
		Name = templateName,
		ThreatBarHeight = 0.1, -- Faktor auf Gesamthöhe
		EnergyBarHeight = 0.2, -- Faktor auf Gesamthöhe
		BuffBarHeight = 0.2,   -- Faktor auf Gesamthöhe
		OnlyManaBar = false,   -- Wut, Energy etc nicht zeigen
		TargetThreat = false,  -- Threat auf Target anzeigen
		OnlyRemovable = true,  -- Nur Debufffärbung zeigen für Debuffs, die der Spieler entfernen kann
		BarTexture = "Smooth",
		HighlightTexture = "Interface\\FriendsFrame\\UI-FriendsFrame-HighlightBar",
		NameJustifyV = "TOP",
		NameJustifyH = "LEFT",
		NameFont = "Myriad Condensed Web",
		NameFontSize = 11,
		NameFontFlags = "OUTLINE",
		LifeJustifyV = "TOP",
		LifeJustifyH = "RIGHT",
		LifeFont = "Myriad Condensed Web",
		LifeFontSize = 10,
		LifeFontFlags = "OUTLINE",
		LifeDisplayStyle = 1, -- 1 = "-21k", 2 = "56%"
		IncomingJustifyV = "BOTTOM",
		IncomingJustifyH = "RIGHT",
		IncomingFont = "Myriad Condensed Web",
		IncomingFontSize = 10,
		IncomingFontFlags = "OUTLINE",
		IncomingBarR = 0,
		IncomingBarG = 0,
		IncomingBarB = 1,
		IncomingBarA = 0.5,
		Border = 5,
		MaxBuffs = 4,
		MaxDebuffs = 3,
		Detailed = false, -- detailiertes Frame
	}
	self.templates[templateName] = tpl

	if self.db.global.templates then
		self.db.global.templates[templateName] = self.db.global.templates[templateName] or {}
	end

	return tpl
end

function BUF_Factory:ApplyOptions(templateName)
	local template = self:GetTemplate(templateName)
	local tplOpt = nil
	if self.db.global.templates then
		tplOpt = self.db.global.templates[templateName]
	end
	if tplOpt then
		template.Detailed = tplOpt.Detailed
		template.BarTexture = (tplOpt.BarTexture or template.BarTexture)
		template.ThreatBarHeight = (tplOpt.ThreatBarHeight or 20) / 100
		template.EnergyBarHeight = (tplOpt.EnergyBarHeight or 20) / 100
		template.BuffBarHeight = (tplOpt.BuffBarHeight or 20) / 100
		template.TargetThreat = tplOpt.TargetThreat
		template.OnlyManaBar = tplOpt.OnlyManaBar
		template.OnlyRemovable = tplOpt.OnlyRemovable
		template.MaxBuffs = tplOpt.MaxBuffs or template.MaxBuffs
		template.MaxDebuffs = tplOpt.MaxDebuffs or template.MaxDebuffs
		template.NameJustifyV = (tplOpt.NameJustifyV or template.NameJustifyV)
		template.NameJustifyH = (tplOpt.NameJustifyH or template.NameJustifyH)
		template.NameFont = (tplOpt.NameFont or template.NameFont)
		template.NameFontSize = (tplOpt.NameFontSize or template.NameFontSize)
		template.NameFontFlags = (tplOpt.NameFontFlags or template.NameFontFlags)
		template.LifeJustifyV = (tplOpt.LifeJustifyV or template.LifeJustifyV)
		template.LifeJustifyH = (tplOpt.LifeJustifyH or template.LifeJustifyH)
		template.LifeDisplayStyle = (tplOpt.LifeDisplayStyle or 1)
		template.LifeFont = (tplOpt.LifeFont or template.LifeFont)
		template.LifeFontSize = (tplOpt.LifeFontSize or template.LifeFontSize)						
		template.LifeFontFlags = (tplOpt.LifeFontFlags or template.LifeFontFlags)
		template.IncomingJustifyV = (tplOpt.IncomingJustifyV or template.IncomingJustifyV)
		template.IncomingJustifyH = (tplOpt.IncomingJustifyH or template.IncomingJustifyH)
		template.IncomingFont = (tplOpt.IncomingFont or template.IncomingFont)
		template.IncomingFontSize = (tplOpt.IncomingFontSize or template.IncomingFontSize)
		template.IncomingFontFlags = (tplOpt.IncomingFontFlags or template.IncomingFontFlags)
		template.IncomingBarR = (tplOpt.IncomingBarR or template.IncomingBarR)
		template.IncomingBarG = (tplOpt.IncomingBarG or template.IncomingBarG)
		template.IncomingBarB = (tplOpt.IncomingBarB or template.IncomingBarB)
		template.IncomingBarA = (tplOpt.IncomingBarA or template.IncomingBarA)
	end
		
	-- Alle Unit Frames aktualisieren
	BUF_Roster:UpdateUnitFrameStyle()
	return tplOpt
end

function BUF_Factory:CreateUnitFrameStructure(parent)
	local uf
	uf = {
		-- Allgemeine Attribute
		area = parent,
		unitId = "",
		vehicleId = "", -- UnitId des vehicles der entsprechenden Unit
		displayUnitId = "", -- UnitId die zur Zeit angezeigt wird (entweder unitId oder vehicleId)
		unitGUID = "",		
		active = false,		
		debuffCount = 0,
		buffCount = 0,
		activeDebuff = "",
		lastCleanup = 0, -- Zeitpunkt, an dem zuletzt die Auren komplett neu gelesen wurden
		soulstoneExpireTime = 0,
		numEmergencyDebuff = 0,
		incoming = 0,
		lastDeadTime = 0,
		lastSpell = 0,
		guiCreated = false,
		detailedCreated = false,
		shown = false,
			
		Width = 0,
		Height = 0,	
	}
	
	return uf
end

function BUF_Factory:CreateUnitFrameGUI(uf, relativeFrame, relativePoint, offx, offy)
	local curTemplate = self:GetTemplate(uf.area.Template)
	uf.guiCreated = true
	
	-- Grundframe des UnitFrame
	uf.BaseFrame = CreateFrame("Frame", nil, uf.area.BaseFrame)
	uf.BaseFrame.uf = uf
	uf.BaseFrame:SetWidth(uf.Width)
	uf.BaseFrame:SetHeight(uf.Height)	
	uf.BaseFrame:SetPoint("TOPLEFT", relativeFrame, relativePoint, offx, offy)	

    uf.BaseFrame:SetScript("OnShow", 
		function(frame, arg1)
			AuraCache:UpdateGUID(frame.uf.unitId)
			BUF_Factory:UpdateUnitFrameComplete(frame.uf)
		end
	)

	uf.BaseFrame:SetScript("OnHide",
		function(frame, arg1)
			AuraCache:UpdateGUID(frame.uf.unitId)
		end
	)

	uf.BaseFrame:Show()
		
	-- Hintergrundtextur
	uf.Background = CreateFrame("Frame", nil, uf.BaseFrame)
	uf.Background:SetPoint("TOPLEFT", uf.BaseFrame, "TOPLEFT", -curTemplate.Border, curTemplate.Border)
	uf.Background:SetPoint("BOTTOMRIGHT", uf.BaseFrame, "BOTTOMRIGHT", curTemplate.Border, -curTemplate.Border)
	uf.Background:SetBackdrop({
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground", 
		edgeFile = "Interface\\AddOns\\BakorsUF\\images\\aUFBorder.tga", 
		tile = true, tileSize = 16, edgeSize = 8, 
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	})			
	uf.Background:SetBackdropColor(0, 0, 0, 0.3)

	-- falls möglich SecureButton
	self:CreateSecureButton(uf)

	-- Threatbalken
	uf.ThreatBar = CreateFrame("StatusBar", nil, uf.BaseFrame, "TextStatusBar")
	uf.ThreatBar:SetPoint("TOPLEFT", uf.BaseFrame, "TOPLEFT")	
	uf.ThreatBar:SetWidth(uf.Width)
	uf.ThreatBar:SetHeight(uf.Height * curTemplate.ThreatBarHeight) 
	uf.ThreatBar:SetStatusBarTexture(bUF.LSM:Fetch(bUF.LSM.MediaType.STATUSBAR, curTemplate.BarTexture))
	uf.ThreatBar:SetStatusBarColor(0.0, 0.0, 0.0)
	uf.ThreatBar:SetMinMaxValues(0, 100)	
	
	-- prognostizierter Lebensbalken
	uf.FutureHealthBar = CreateFrame("StatusBar", nil, uf.BaseFrame, "TextStatusBar")
	uf.FutureHealthBar:SetFrameStrata("LOW")
	uf.FutureHealthBar:SetPoint("TOPLEFT", uf.BaseFrame, "TOPLEFT", 0, -uf.Height * curTemplate.ThreatBarHeight)
	uf.FutureHealthBar:SetWidth(uf.Width)
	uf.FutureHealthBar:SetHeight(uf.Height * (1 - curTemplate.EnergyBarHeight - curTemplate.ThreatBarHeight - curTemplate.BuffBarHeight)) 
	uf.FutureHealthBar:SetStatusBarTexture(bUF.LSM:Fetch(bUF.LSM.MediaType.STATUSBAR, curTemplate.BarTexture))
	uf.FutureHealthBar:SetStatusBarColor(curTemplate.IncomingBarR, curTemplate.IncomingBarG, curTemplate.IncomingBarB, curTemplate.IncomingBarA)
	uf.FutureHealthBar:SetMinMaxValues(0, 100)	
    
	-- Lebensbalken
	uf.HealthBar = CreateFrame("StatusBar", nil, uf.BaseFrame, "TextStatusBar")
	uf.HealthBar:SetPoint("TOPLEFT", uf.BaseFrame, "TOPLEFT", 0, -uf.Height * curTemplate.ThreatBarHeight)
	uf.HealthBar:SetWidth(uf.Width)
	uf.HealthBar:SetHeight(uf.FutureHealthBar:GetHeight()) 
	uf.HealthBar:SetStatusBarTexture(bUF.LSM:Fetch(bUF.LSM.MediaType.STATUSBAR, curTemplate.BarTexture))
	uf.HealthBar:SetStatusBarColor(0.0, 1.0, 0.0)
	uf.HealthBar:SetMinMaxValues(0, 100)	

	-- Energiebalken
	uf.EnergyBar = CreateFrame("StatusBar", nil, uf.BaseFrame, "TextStatusBar")
	uf.EnergyBar:SetPoint("TOPLEFT", uf.HealthBar, "BOTTOMLEFT")
	uf.EnergyBar:SetWidth(uf.Width)
	uf.EnergyBar:SetHeight(uf.Height * curTemplate.EnergyBarHeight) 
	uf.EnergyBar:SetStatusBarTexture(bUF.LSM:Fetch(bUF.LSM.MediaType.STATUSBAR, curTemplate.BarTexture))
	uf.EnergyBar:SetStatusBarColor(0.0, 1.0, 0.0)
	uf.EnergyBar:SetMinMaxValues(0, 100)	
	
	-- Beschriftungen  
    -- Raidsymbol
	uf.Raidsymbol = uf.HealthBar:CreateTexture(nil, "OVERLAY")
	uf.Raidsymbol:SetWidth(16)
	uf.Raidsymbol:SetHeight(16)
	uf.Raidsymbol:SetPoint("TOP", uf.HealthBar)
	uf.Raidsymbol:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
	uf.Raidsymbol:Hide()

	-- Schadensspell
	uf.Spellsymbol = uf.HealthBar:CreateTexture(nil, "OVERLAY")
	uf.Spellsymbol:SetWidth(16)
	uf.Spellsymbol:SetHeight(16)
	uf.Spellsymbol:SetPoint("RIGHT", uf.Raidsymbol, "LEFT", 0, 0)
	uf.Spellsymbol:Hide()
	
	-- Namen
	uf.NamePlate = uf.HealthBar:CreateFontString()	
	uf.NamePlate:SetPoint("TOPLEFT", uf.HealthBar, "TOPLEFT", 1, -1)
	uf.NamePlate:SetPoint("BOTTOMRIGHT", uf.HealthBar)
	uf.NamePlate:SetJustifyV(curTemplate.NameJustifyV)
    uf.NamePlate:SetJustifyH(curTemplate.NameJustifyH)
    uf.NamePlate:SetFont(bUF.LSM:Fetch(bUF.LSM.MediaType.FONT, curTemplate.NameFont), curTemplate.NameFontSize, curTemplate.NameFontFlags)
    uf.NamePlate:SetTextColor(1, 1, 1, 1)	
    
    -- Lebensdefizit
    uf.HealthDeficit = uf.HealthBar:CreateFontString()
	uf.HealthDeficit:SetPoint("TOPLEFT", uf.HealthBar)
	uf.HealthDeficit:SetPoint("BOTTOMRIGHT", uf.HealthBar)
	uf.HealthDeficit:SetJustifyV(curTemplate.LifeJustifyV)
    uf.HealthDeficit:SetJustifyH(curTemplate.LifeJustifyH)
    uf.HealthDeficit:SetFont(bUF.LSM:Fetch(bUF.LSM.MediaType.FONT, curTemplate.LifeFont), curTemplate.LifeFontSize, curTemplate.LifeFontFlags)
    uf.HealthDeficit:SetTextColor(1, 1, 1, 1)
    
    -- Incoming Heal
    uf.IncomingHeal = uf.HealthBar:CreateFontString()
    uf.IncomingHeal:SetPoint("TOPLEFT", uf.HealthBar)
    uf.IncomingHeal:SetPoint("BOTTOMRIGHT", uf.HealthBar)
	uf.IncomingHeal:SetJustifyV(curTemplate.IncomingJustifyV)
    uf.IncomingHeal:SetJustifyH(curTemplate.IncomingJustifyH)
    uf.IncomingHeal:SetFont(bUF.LSM:Fetch(bUF.LSM.MediaType.FONT, curTemplate.IncomingFont), curTemplate.IncomingFontSize, curTemplate.IncomingFontFlags)
    uf.IncomingHeal:SetTextColor(1, 1, 1, 1)

	-- Buff Bars
	local numbuffs = self:BuffsAssigned() or 4
	uf.BuffBar = {}
	for i = 1, 4 do
		uf.BuffBar[i] = BBB_Factory:CreateBuffBar(uf.BaseFrame, i, curTemplate)
		uf.BuffBar[i].BaseFrame:SetPoint("BOTTOMLEFT", uf.BaseFrame, "BOTTOMLEFT", uf.Width * (i - 1) / numbuffs, 0)
		uf.BuffBar[i].BaseFrame:SetWidth(uf.Width / numbuffs)
		uf.BuffBar[i].BaseFrame:SetHeight(uf.Height * curTemplate.BuffBarHeight) 
	end
	
	-- Debuffs
	uf.Debuffs = {}
	for i = 1, curTemplate.MaxDebuffs do
		uf.Debuffs[i] = BAF_Factory:CreateAuraFrame(uf.HealthBar, "DEBUFF")
		uf.Debuffs[i].BaseFrame:SetPoint("BOTTOMRIGHT", uf.HealthBar, "TOPRIGHT", (i - 1) * -BAF_Factory.AuraSize, uf.Height * (curTemplate.ThreatBarHeight + curTemplate.BuffBarHeight - 1))
	end
	
	-- Buffs
	uf.Buffs = {}	
	for i = 1, curTemplate.MaxBuffs do
		uf.Buffs[i] = BAF_Factory:CreateAuraFrame(uf.HealthBar, "BUFF")
		uf.Buffs[i].BaseFrame:SetPoint("BOTTOMLEFT", uf.HealthBar, "TOPLEFT", (i - 1) * BAF_Factory.AuraSize, uf.Height * (curTemplate.ThreatBarHeight + curTemplate.BuffBarHeight - 1))	
	end

	if curTemplate.Detailed then
		self:CreateUnitFrameDetailedGUI(uf)
	end
end

function BUF_Factory:CreateUnitFrameDetailedGUI(uf)
	local curTemplate = self:GetTemplate(uf.area.Template)
	uf.detailedCreated = true

	uf.StatusIcon = uf.HealthBar:CreateTexture(nil, "OVERLAY")
	uf.StatusIcon:SetWidth(24)
	uf.StatusIcon:SetHeight(24)
	uf.StatusIcon:SetPoint("CENTER", uf.HealthBar, "BOTTOMLEFT")
	uf.StatusIcon:SetTexture("Interface\\CharacterFrame\\UI-StateIcon")
	uf.StatusIcon:Hide()

	uf.LeaderIcon = uf.HealthBar:CreateTexture(nil, "OVERLAY")
	uf.LeaderIcon:SetWidth(16)
	uf.LeaderIcon:SetHeight(16)
	uf.LeaderIcon:SetPoint("CENTER", uf.HealthBar, "TOPLEFT")
	uf.LeaderIcon:SetTexture("Interface\\GroupFrame\\UI-Group-LeaderIcon")
	uf.LeaderIcon:Hide()

	uf.PvPIcon = uf.HealthBar:CreateTexture(nil, "OVERLAY")
	uf.PvPIcon:SetWidth(24)
	uf.PvPIcon:SetHeight(24)
	uf.PvPIcon:SetPoint("CENTER", uf.HealthBar, "TOPRIGHT")
	uf.PvPIcon:Hide()

	uf.StatusLabel = uf.EnergyBar:CreateFontString()
	uf.StatusLabel:SetPoint("TOPLEFT", uf.EnergyBar)
	uf.StatusLabel:SetPoint("BOTTOMRIGHT", uf.EnergyBar)
	uf.StatusLabel:SetJustifyV("MIDDLE")
	uf.StatusLabel:SetJustifyH("LEFT")
	uf.StatusLabel:SetFont(bUF.LSM:Fetch(bUF.LSM.MediaType.FONT, curTemplate.LifeFont), curTemplate.LifeFontSize, curTemplate.LifeFontFlags)
	uf.StatusLabel:SetTextColor(1, 1, 1, 1)

	uf.EnergyLabel = uf.EnergyBar:CreateFontString()
	uf.EnergyLabel:SetPoint("TOPLEFT", uf.EnergyBar)
	uf.EnergyLabel:SetPoint("BOTTOMRIGHT", uf.EnergyBar)
	uf.EnergyLabel:SetJustifyV("MIDDLE")
	uf.EnergyLabel:SetJustifyH("RIGHT")
	uf.EnergyLabel:SetFont(bUF.LSM:Fetch(bUF.LSM.MediaType.FONT, curTemplate.LifeFont), curTemplate.LifeFontSize, curTemplate.LifeFontFlags)
	uf.EnergyLabel:SetTextColor(1, 1, 1, 1)
end

function BUF_Factory:SetPoint(uf, relativeFrame, relativePoint, offx, offy)
	if not uf.guiCreated then
		self:CreateUnitFrameGUI(uf, relativeFrame, relativePoint, offx, offy)
	else
		uf.BaseFrame:SetPoint("TOPLEFT", relativeFrame, relativePoint, offx, offy)
	end
end

local function DropDownUnit(frame, unit, button, dropDown, number)
	if dropDown == FriendsDropDown then
		dropDown.displayMode = "MENU"
		dropDown.initialize = RaidFrameDropDown_Initialize
	end

	if dropDown then
		HideDropDownMenu(1)
		dropDown.unit = unit
		dropDown.name = UnitName(unit)
		dropDown.id = number
		ToggleDropDownMenu(1, nil, dropDown, "cursor")
	end
end

-- SecureActionButton erzeugen, falls zur Zeit möglich
function BUF_Factory:CreateSecureButton(uf)
	if InCombatLockdown() then return end
	
	uf.SecureButton = CreateFrame("Button", nil, uf.BaseFrame, "SecureActionButtonTemplate")	
	uf.SecureButton.uf = uf
	uf.SecureButton:RegisterForClicks("AnyDown")
	uf.SecureButton:SetAllPoints(uf.BaseFrame)
	uf.SecureButton:SetHighlightTexture("Interface\\FriendsFrame\\UI-FriendsFrame-HighlightBar")
	
	uf.SecureButton:SetScript("OnEnter", function(this) BUF_Factory:OnEnter(this.uf) end)
	uf.SecureButton:SetScript("OnLeave", function(this) BUF_Factory:OnLeave(this.uf) end) 
	
	uf.SecureButton:SetAttribute("toggleForVehicle", true)
	uf.SecureButton:SetAttribute("allowVehicleTarget", true)
	
	uf.SecureButton.menu = function(frame, unit, button)
		DropDownUnit(frame, unit, button, uf.dropDown, uf.number)
	end
		
	self:UpdateSecureButton(uf)
end

-- SecureActionButton Attribute setzen
function BUF_Factory:UpdateSecureButton(uf)
	if InCombatLockdown() or not uf.guiCreated then return end
	local _, playerClass = UnitClass("player")

	local oldid = uf.BaseFrame:GetAttribute("unit")	
	uf.BaseFrame:SetAttribute("unit", uf.unitId)
	
	AuraCache:UnregisterUnitID(oldid)
	AuraCache:RegisterUnitID(uf.unitId)

	uf.SecureButton:SetAttribute("type", "target")
	uf.SecureButton:SetAttribute("unit", uf.unitId)
	
	uf.SecureButton:SetAttribute("type1", "target")
	uf.SecureButton:SetAttribute("unit1", uf.unitId)
	
	uf.SecureButton:SetAttribute("shift-type2", "menu")
	uf.SecureButton:SetAttribute("shift-unit2", uf.unitId)
	
	local ms = self.db.global.clickcast[playerClass]
	if ms then
		if ms.spell2 then
			uf.SecureButton:SetAttribute("type2", "spell")
			uf.SecureButton:SetAttribute("spell2", ms.spell2)
			uf.SecureButton:SetAttribute("unit2", uf.unitId)	
		end
		if ms.spell3 then
			uf.SecureButton:SetAttribute("type3", "spell")
			uf.SecureButton:SetAttribute("spell3", ms.spell3)
			uf.SecureButton:SetAttribute("unit3", uf.unitId)	
		end
		if ms.spell4 then
			uf.SecureButton:SetAttribute("type4", "spell")
			uf.SecureButton:SetAttribute("spell4", ms.spell4)
			uf.SecureButton:SetAttribute("unit4", uf.unitId)	
		end
		if ms.spell5 then
			uf.SecureButton:SetAttribute("type5", "spell")
			uf.SecureButton:SetAttribute("spell5", ms.spell5)
			uf.SecureButton:SetAttribute("unit5", uf.unitId)	
		end
	end
end

function BUF_Factory:OnEnter(uf)
	GameTooltip_SetDefaultAnchor(GameTooltip, UIParent)
	GameTooltip:SetUnit(uf.unitId)
	GameTooltip:AddLine(uf.unitId, 1, 1, 0)
	GameTooltip:Show()
end

function BUF_Factory:OnLeave(uf)
	GameTooltip:Hide()
end

function BUF_Factory:UpdateUnitFrameStyle(uf)
	local curTemplate = self:GetTemplate(uf.area.Template)
	
	if uf.guiCreated then
		uf.FutureHealthBar:SetStatusBarTexture(bUF.LSM:Fetch(bUF.LSM.MediaType.STATUSBAR, curTemplate.BarTexture))
		uf.FutureHealthBar:SetStatusBarColor(curTemplate.IncomingBarR, curTemplate.IncomingBarG, curTemplate.IncomingBarB, curTemplate.IncomingBarA)
		uf.HealthBar:SetStatusBarTexture(bUF.LSM:Fetch(bUF.LSM.MediaType.STATUSBAR, curTemplate.BarTexture))
		uf.EnergyBar:SetStatusBarTexture(bUF.LSM:Fetch(bUF.LSM.MediaType.STATUSBAR, curTemplate.BarTexture))

		uf.NamePlate:SetJustifyV(curTemplate.NameJustifyV)
		uf.NamePlate:SetJustifyH(curTemplate.NameJustifyH)
		uf.NamePlate:SetFont(bUF.LSM:Fetch(bUF.LSM.MediaType.FONT, curTemplate.NameFont), curTemplate.NameFontSize, curTemplate.NameFontFlags)
	
		uf.HealthDeficit:SetJustifyV(curTemplate.LifeJustifyV)
		uf.HealthDeficit:SetJustifyH(curTemplate.LifeJustifyH)
		uf.HealthDeficit:SetFont(bUF.LSM:Fetch(bUF.LSM.MediaType.FONT, curTemplate.LifeFont), curTemplate.LifeFontSize, curTemplate.LifeFontFlags)

		uf.IncomingHeal:SetJustifyV(curTemplate.IncomingJustifyV)
		uf.IncomingHeal:SetJustifyH(curTemplate.IncomingJustifyH)
		uf.IncomingHeal:SetFont(bUF.LSM:Fetch(bUF.LSM.MediaType.FONT, curTemplate.IncomingFont), curTemplate.IncomingFontSize, curTemplate.IncomingFontFlags)	

		local numbuffs = self:BuffsAssigned() or 4
		for i = 1, 4 do
			uf.BuffBar[i].BaseFrame:SetPoint("TOPLEFT", uf.EnergyBar, "BOTTOMLEFT", uf.Width * (i - 1) / numbuffs, 0)
			uf.BuffBar[i].BaseFrame:SetWidth(uf.Width / numbuffs)
		end
		for i = 1, curTemplate.MaxDebuffs do	
			if not uf.Debuffs[i] then
				uf.Debuffs[i] = BAF_Factory:CreateAuraFrame(uf.HealthBar, "DEBUFF")
			end
			BAF_Factory:UpdateStyle(uf.Debuffs[i])
		end
		for i = 1, curTemplate.MaxBuffs do
			if not uf.Buffs[i] then
				uf.Buffs[i] = BAF_Factory:CreateAuraFrame(uf.HealthBar, "UFF")
			end
			BAF_Factory:UpdateStyle(uf.Buffs[i])
		end

		if curTemplate.Detailed then
			if not uf.detailedCreated then
				self:CreateUnitFrameDetailedGUI(uf)
			end
			uf.StatusLabel:SetFont(bUF.LSM:Fetch(bUF.LSM.MediaType.FONT, curTemplate.LifeFont), curTemplate.LifeFontSize, curTemplate.LifeFontFlags)
			uf.EnergyLabel:SetFont(bUF.LSM:Fetch(bUF.LSM.MediaType.FONT, curTemplate.LifeFont), curTemplate.LifeFontSize, curTemplate.LifeFontFlags)
		end
	end
end

function BUF_Factory:UpdateUnitFrameSize(uf, newWidth, newHeight)
	local curTemplate = self:GetTemplate(uf.area.Template)

	uf.Width = newWidth
	uf.Height = newHeight

	if uf.guiCreated then
		uf.BaseFrame:SetWidth(uf.Width)
		uf.BaseFrame:SetHeight(uf.Height)
		uf.HealthBar:SetWidth(uf.Width)

		uf.HealthBar:SetPoint("TOPLEFT", uf.BaseFrame, "TOPLEFT", 0, -uf.Height * curTemplate.ThreatBarHeight)
		uf.FutureHealthBar:SetPoint("TOPLEFT", uf.BaseFrame, "TOPLEFT", 0, -uf.Height * curTemplate.ThreatBarHeight)
	
		-- ggf. den Energiebalken ausblenden
		local _, powerTypeString = UnitPowerType(uf.unitId)
		if powerTypeString == "MANA" or (not curTemplate.OnlyManaBar) then
			uf.ThreatBar:SetHeight(uf.Height * curTemplate.ThreatBarHeight)
			uf.HealthBar:SetHeight(uf.Height * (1 - curTemplate.EnergyBarHeight - curTemplate.ThreatBarHeight - curTemplate.BuffBarHeight)) 
			uf.EnergyBar:SetHeight(uf.Height * curTemplate.EnergyBarHeight)
			uf.EnergyBar:Show()
		else
			uf.ThreatBar:SetHeight(uf.Height * curTemplate.ThreatBarHeight)
			uf.HealthBar:SetHeight(uf.Height * (1 - curTemplate.ThreatBarHeight - curTemplate.BuffBarHeight))
			uf.EnergyBar:SetHeight(0)
			uf.EnergyBar:Hide()
		end
		
		for i = 1, 4 do
			uf.BuffBar[i].BaseFrame:SetHeight(uf.Height * curTemplate.BuffBarHeight) 
		end
				
		uf.FutureHealthBar:SetWidth(uf.Width)
		uf.FutureHealthBar:SetHeight(uf.HealthBar:GetHeight())		
		uf.EnergyBar:SetWidth(uf.Width)
	
		local auraHeight = math.max(14, uf.Height * (1 - curTemplate.ThreatBarHeight - curTemplate.BuffBarHeight) / 2)
		for i = 1, curTemplate.MaxDebuffs do
			BAF_Factory:UpdateHeight(uf.Debuffs[i], auraHeight)			
			uf.Debuffs[i].BaseFrame:SetPoint("BOTTOMRIGHT", uf.HealthBar, "TOPRIGHT", (i - 1) * -auraHeight, uf.Height * (curTemplate.ThreatBarHeight + curTemplate.BuffBarHeight - 1))
		end
		for i = 1, curTemplate.MaxBuffs do
			if uf.Buffs[i] then
				BAF_Factory:UpdateHeight(uf.Buffs[i], auraHeight)
				uf.Buffs[i].BaseFrame:SetPoint("BOTTOMLEFT", uf.HealthBar, "TOPLEFT", (i - 1) * auraHeight, uf.Height * (curTemplate.ThreatBarHeight + curTemplate.BuffBarHeight - 1))
			end
		end	
	end
end

function BUF_Factory:HasMissingBuff(uf, unitId)
	local _, className = UnitClass("player")
	local mb
	local found, allFound, flaskFound
	local guid = AuraCache:GetUnitGUID(unitId)
	
	if bUF.checkMode then
		-- Für alle Klassen fehlende Buffs checken
		local curTemplate = self:GetTemplate(uf.area.Template)

		uf.buffCount = 0													

		-- essen 45548
		-- trinken 57073

		if self.db.global.CheckFood then
			allFound = false
			for k, v in pairs(self.WellFedList) do
				if v then
					found = AuraCache:HasAura(guid, "BUFF", k)	
					if found then
						allFound = true
						break
					end
				end
			end
			if not allFound and uf.buffCount < curTemplate.MaxBuffs then
				uf.buffCount = uf.buffCount + 1

				-- Falls Essen Buff aktiv, Restzeit anzeigen
				local duration, expirationTime = 0, 0
				local eatingAuraKey = AuraCache:FindFirst(guid, "BUFF", self.Eating)
				if eatingAuraKey then
					local infotab = AuraCache:GetInfoTab(guid, "BUFF")
					duration = 10
					expirationTime = infotab.expirationTime[eatingAuraKey] - 20				
				end

				BAF_Factory:UpdateAuraFrame(uf.Buffs[uf.buffCount], 
					57399, AuraCache.NILGUID, 1, duration, expirationTime
				)		
			end
		else
			allFound = true
		end

		if self.db.global.CheckFlasks then
			flaskFound = false
			for k, v in pairs(self.FlaskList) do
				if v then
					found = AuraCache:HasAura(guid, "BUFF", k)	
					if found then
						flaskFound = true
						break
					end
				end
			end
			if not flaskFound and uf.buffCount < curTemplate.MaxBuffs then
				uf.buffCount = uf.buffCount + 1

				BAF_Factory:UpdateAuraFrame(uf.Buffs[uf.buffCount], 
					67019, AuraCache.NILGUID, 1, 0, 0
				)	
			end
			if not flaskFound then allFound = false end
		end

		-- Buffs aus MissingBuff überprüfen
		for _, v in pairs(self.MissingBuff) do
			local hasBuffer = false
			local hasBuff = false
			local firstId = 0

			for bufferClass, buffIds in pairs(v) do
				if BUF_Roster.classCounts[bufferClass] > 0 then
					hasBuffer = true

					for _, buffId in ipairs(buffIds) do
						if firstId == 0 then
							firstId = buffId
						end

						found = AuraCache:HasAura(guid, "BUFF", buffId)
						if found then 
							hasBuff = true
							break
						end
					end
				end
			end

			if hasBuffer and not hasBuff then
				if uf.buffCount < curTemplate.MaxBuffs then			
					uf.buffCount = uf.buffCount + 1

					BAF_Factory:UpdateAuraFrame(uf.Buffs[uf.buffCount], 
						firstId, AuraCache.NILGUID, 1, 0, 0
					)		
				end
				allFound = false
			end
		end
		
		for index = uf.buffCount + 1, curTemplate.MaxBuffs do
			BAF_Factory:HideAuraFrame(uf.Buffs[index])	
		end

		return not allFound
	else
		allFound = true

		-- Buffs aus MissingBuff überprüfen
		for _, v in pairs(self.MissingBuff) do
			local hasBuffer = false
			local playerBuff = false			
			local hasBuff = false
			local firstId = 0

			for bufferClass, buffIds in pairs(v) do
				if BUF_Roster.classCounts[bufferClass] > 0 then
					hasBuffer = true
				end
				if bufferClass == className then
					playerBuff = true
				end

				for _, buffId in ipairs(buffIds) do
					if firstId == 0 then
						firstId = buffId
					end

					found = AuraCache:HasAura(guid, "BUFF", buffId)
					if found then 
						hasBuff = true
						break
					end
				end
			end

			if hasBuffer and playerBuff and not hasBuff then
				allFound = false
			end
		end

		return not allFound
	end
end

function BUF_Factory:GetDebuffType(unitId, onlyRemovable)
	local unitguid = AuraCache:GetUnitGUID(unitId)
	if AuraCache:HasDebuffType(unitguid, "Magic") then
		if bUF.canMagic or (not onlyRemovable) then return "Magic" end
	end
	if AuraCache:HasDebuffType(unitguid, "Disease") then
		if bUF.canDisease or (not onlyRemovable) then return "Disease" end
	end
	if AuraCache:HasDebuffType(unitguid, "Poison") then
		if bUF.canPoison or (not onlyRemovable) then return "Poison" end
	end
	if AuraCache:HasDebuffType(unitguid, "Curse") then
		if bUF.canCurse or (not onlyRemovable) then return "Curse" end
	end
	return nil
end

function BUF_Factory:GetHealthBarColor(uf, curHealth, curHealthMax)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then
		local curTemplate = self:GetTemplate(uf.area.Template)
		local isEnemy = not UnitIsFriend("player", unitId) --  UnitCanAttack("player", unitId)
		local debuffType = self:GetDebuffType(unitId, curTemplate.OnlyRemovable)

		if UnitIsDeadOrGhost(unitId) or not UnitIsConnected(unitId) then
			return 0.2, 0.2, 0.2
		elseif (UnitIsPossessed(unitId) or UnitIsCharmed(unitId)) and not inVehicle then
			local cdc = self.DebuffTypeColor["Possessed"]
			return cdc.r, cdc.g, cdc.b
		elseif (uf.numEmergencyDebuff or 0) > 0 or isEnemy then
			if UnitIsTapped(unitId) and not UnitIsTappedByPlayer(unitId) then
				return 0.5, 0.5, 0.5
			else
				return 1, 0, 0
			end
		elseif debuffType then
			local cdc = self.DebuffTypeColor[debuffType]
			return cdc.r, cdc.g, cdc.b
		elseif self:HasMissingBuff(uf, unitId) then
			return 1, 1, 1
		else
			local curHealthDeficit = curHealthMax - curHealth
			local curHealthPercentage = curHealth / curHealthMax

			-- Farbverlauf abhängig von Prozentualem Leben:
			-- 100% = Grün (r = 0, g = 1, b = 0)
			-- 75% = Gelb (r = 1, g = 1, b = 0)
			-- 0% = Rot (r = 1, g = 0, b = 0)
			return math.min(1, 4 - curHealthPercentage * 4), math.min(1, curHealthPercentage * 1.33), 0
		end	
	end
	return 0, 0, 0
end

function BUF_Factory:UpdateUnitFrameComplete(uf)
	uf.area.PendingUpdate = true
end

function BUF_Factory:UpdateUnitFrame(uf)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then
		self:UpdateName(uf)
		self:UpdateStatus(uf)
		self:UpdateFlags(uf)
		self:UpdateTarget(uf)
		self:UpdateInRange(uf)
		self:UpdateIncomingHeal(uf)
		self:UpdateMaxHealth(uf)
		self:UpdatePowerDisplay(uf)
		self:UpdateMaxPower(uf)
		self:UpdateThreat(uf)
		self:UpdateIcons(uf)
		self:CleanupUnitAura(uf)

		local isDead = UnitIsDeadOrGhost(unitId)
		if not isDead then
			BUF_Roster.resurrection[unitId] = nil
		end				
		if uf.lastSpell + 1 < GetTime() and (not isDead) then
			uf.Spellsymbol:Hide()
		end
	end
end

function BUF_Factory:UpdateName(uf)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then
		local _, className = UnitClass(unitId)
		local npc = RAID_CLASS_COLORS[className]
		if npc then
			uf.NamePlate:SetTextColor(npc.r, npc.g, npc.b)
		end
		
		uf.NamePlate:SetText(UnitName(unitId))
	end
end

function BUF_Factory:UpdateStatus(uf)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId and uf.StatusLabel then	
		local level = UnitLevel(unitId)
		if (level or -1) == -1 then level = "??" end
		local locClass = UnitClass(unitId) or ""
		local locRace = UnitRace(unitId) or ""
		if not UnitIsPlayer(unitId) then locClass = UnitCreatureType(unitId) or "" end
		uf.StatusLabel:SetText(level .. " " .. locRace .. " " .. locClass)
	end
end

function BUF_Factory:UpdateFlags(uf)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then	
		local now = GetTime()
		local isAFK = UnitIsAFK(unitId)
		local isDead = UnitIsDeadOrGhost(unitId)
		local isConnected = UnitIsConnected(unitId)

		if isDead then	
			if BUF_Roster.resurrection[unitId] then
				uf.HealthDeficit:SetTextColor(0, 1, 0)
			else
				uf.HealthDeficit:SetTextColor(1, 0, 0)
			end
			if uf.soulstoneExpireTime > uf.lastDeadTime and uf.lastDeadTime + 360 > now then -- Soulstone kann 6 min lang angenommen werden
				uf.HealthDeficit:SetText("SOULSTONE")
			else
				uf.HealthDeficit:SetText("DEAD")
			end
		elseif ifAFK then
			uf.HealthDeficit:SetText("AFK")
		elseif not isConnected then
			uf.HealthDeficit:SetTextColor(0, 1, 0)
			uf.HealthDeficit:SetText("OFFLINE")
		end
	end	
end

function BUF_Factory:UpdateTarget(uf)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then
		if UnitIsUnit(unitId, "target") then
			uf.Background:SetBackdropBorderColor(1, 1, 1)
		else
			uf.Background:SetBackdropBorderColor(0, 0, 0)
		end
	end
end

function BUF_Factory:UpdateInRange(uf)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then
		if UnitInRange(unitId) or not (UnitInRaid(unitId) or UnitInParty(unitId)) then
			uf.BaseFrame:SetAlpha(1)
		else
			uf.BaseFrame:SetAlpha(0.4)
		end
	end
end

function BUF_Factory:UpdateMaxHealth(uf)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then
		local curHealthMax = UnitHealthMax(unitId)

		uf.FutureHealthBar:SetMinMaxValues(0, curHealthMax)
		uf.HealthBar:SetMinMaxValues(0, curHealthMax)
		self:UpdateHealth(uf)
	end
end

function BUF_Factory:UpdateHealth(uf)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then
		local curTemplate = self:GetTemplate(uf.area.Template)
		local isEnemy = not UnitIsFriend("player", unitId) --  UnitCanAttack("player", unitId)
		local curHealth = UnitHealth(unitId)
		local curHealthMax = UnitHealthMax(unitId)
		local curHealthDeficit = curHealthMax - curHealth
		local curHealthPercentage = curHealth / curHealthMax
		local hbcR, hbcG, hbcB = self:GetHealthBarColor(uf, curHealth, curHealthMax)
				
		uf.FutureHealthBar:SetValue(math.min(curHealthMax, curHealth + uf.incoming))
		uf.HealthBar:SetValue(curHealth)
		uf.HealthBar:SetStatusBarColor(hbcR, hbcG, hbcB)
				
		if isEnemy or curTemplate.LifeDisplayStyle == 2 then
			uf.HealthDeficit:SetTextColor(1, 1, 1)
			if curTemplate.Detailed then
				if curHealthMax > 999999 then
					uf.HealthDeficit:SetFormattedText("%.0f%% %.1fm/%.1fm", curHealth / curHealthMax * 100, curHealth / 1000000, curHealthMax / 1000000)
				elseif curHealthMax > 999 then
					uf.HealthDeficit:SetFormattedText("%.0f%% %.1fk/%.1fk", curHealth / curHealthMax * 100, curHealth / 1000, curHealthMax / 1000)
				else
					uf.HealthDeficit:SetFormattedText("%.0f%% %.0f/%.0f", curHealth / curHealthMax * 100, curHealth, curHealthMax)
				end
			else			
				uf.HealthDeficit:SetFormattedText("%.0f%%", curHealth / curHealthMax * 100)
			end
		else
			uf.HealthDeficit:SetTextColor(1, 1, 1)
			if curHealthDeficit >= 1000 then
				uf.HealthDeficit:SetFormattedText("%.0fk", -curHealthDeficit / 1000)
			else
				uf.HealthDeficit:SetText("")
			end
		end
		self:UpdateFlags(uf)
	end
end

function BUF_Factory:UpdateUnitFrameBarColor(uf)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then
		local curHealth = UnitHealth(unitId)
		local curHealthMax = UnitHealthMax(unitId)
		local hbcR, hbcG, hbcB = self:GetHealthBarColor(uf, curHealth, curHealthMax)
		uf.HealthBar:SetStatusBarColor(hbcR, hbcG, hbcB)
	end		
end

function BUF_Factory:UpdateIncomingHeal(uf)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then
		-- Incoming Heal		
		if self.db.global.IncomingHeal then
			uf.incoming = bUF:GetIncomingHeal(unitId)
		else
			uf.incoming = 0
		end
		if uf.incoming > 0 then
			local curHealth = UnitHealth(unitId)
			local curHealthMax = UnitHealthMax(unitId)
			
			uf.FutureHealthBar:SetValue(math.min(curHealthMax, curHealth + uf.incoming))
			uf.FutureHealthBar:Show()
			uf.IncomingHeal:SetFormattedText("+%.0fk", uf.incoming / 1000)
		else
			uf.FutureHealthBar:Hide()
			uf.IncomingHeal:SetText("")
		end	
	end
end

function BUF_Factory:UpdatePowerDisplay(uf)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then
		local curTemplate = self:GetTemplate(uf.area.Template)
		local _, powerTypeString = UnitPowerType(unitId)
		local pbc = PowerBarColor[powerTypeString]	
		if pbc then
			uf.EnergyBar:SetStatusBarColor(pbc.r, pbc.g, pbc.b)
		end
									
		if powerTypeString == "MANA" or (not curTemplate.OnlyManaBar) then
			uf.ThreatBar:SetHeight(uf.Height * curTemplate.ThreatBarHeight)
			uf.HealthBar:SetHeight(uf.Height * (1 - curTemplate.EnergyBarHeight - curTemplate.ThreatBarHeight - curTemplate.BuffBarHeight)) 
			uf.EnergyBar:SetHeight(uf.Height * curTemplate.EnergyBarHeight)
			uf.EnergyBar:Show()
		else
			uf.ThreatBar:SetHeight(uf.Height * curTemplate.ThreatBarHeight)
			uf.HealthBar:SetHeight(uf.Height * (1 - curTemplate.ThreatBarHeight - curTemplate.BuffBarHeight)) 
			uf.EnergyBar:SetHeight(0)
			uf.EnergyBar:Hide()
		end

		self:UpdateMaxPower(uf)
	end
end

function BUF_Factory:UpdateMaxPower(uf)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then
		uf.EnergyBar:SetMinMaxValues(0, UnitPowerMax(unitId))
		self:UpdatePower(uf)
	end
end

function BUF_Factory:UpdatePower(uf)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then
		local unitpwr = UnitPower(unitId)
		uf.EnergyBar:SetValue(unitpwr)
		if uf.EnergyLabel then
			uf.EnergyLabel:SetText(unitpwr .. "/" .. UnitPowerMax(unitId))
		end		
	end
end

function BUF_Factory:UpdateThreat(uf)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then
		local curTemplate = self:GetTemplate(uf.area.Template)
		local isEnemy = not UnitIsFriend("player", unitId) --  UnitCanAttack("player", unitId)
		if curTemplate.TargetThreat or isEnemy then			
			local isTanking, status, scaledPercent, rawPercent, threatValue
			if isEnemy then
				isTanking, status, scaledPercent, rawPercent, threatValue = UnitDetailedThreatSituation("player", unitId)
			else
				isTanking, status, scaledPercent, rawPercent, threatValue = UnitDetailedThreatSituation(unitId, "target")
			end
			if status then
				local tr, tg, tb = GetThreatStatusColor(status)
				uf.ThreatBar:SetStatusBarColor(tr, tg, tb, 1)
			else
				uf.ThreatBar:SetStatusBarColor(0, 0, 0, 0)
			end
			uf.ThreatBar:SetValue(scaledPercent or 0)
		else
			local status = UnitThreatSituation(unitId)
			if status then
				local tr, tg, tb = GetThreatStatusColor(status)
				uf.ThreatBar:SetStatusBarColor(tr, tg, tb, 1)
			else
				uf.ThreatBar:SetStatusBarColor(0, 0, 0, 0)
			end
			uf.ThreatBar:SetValue(100)
		end
	end
end

function BUF_Factory:UpdateIcons(uf)
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then
		local curTemplate = self:GetTemplate(uf.area.Template)

		-- Raidsymbol
		local targetIndex = GetRaidTargetIndex(unitId)
		if targetIndex then
			SetRaidTargetIconTexture(uf.Raidsymbol, targetIndex)
			uf.Raidsymbol:Show()
		else
			uf.Raidsymbol:Hide()
		end

		if curTemplate.Detailed and uf.detailedCreated then
			-- Status Icon
			if UnitAffectingCombat(unitId) then
				uf.StatusIcon:Show()
				uf.StatusIcon:SetTexCoord(0.5, 1, 0, 0.49)
			elseif unitId == "player" and IsResting() then
				uf.StatusIcon:Show()
				uf.StatusIcon:SetTexCoord(0, 0.5, 0, 0.421875)
			else
				uf.StatusIcon:Hide()
			end

			-- Leader Icon
			if (IsRaidLeader() or IsPartyLeader()) and unitId == "player" then
				uf.LeaderIcon:Show()
			else
				uf.LeaderIcon:Hide()
			end

			-- PvP Icon
			if UnitIsPVPFreeForAll(unitId) then
				uf.PvPIcon:SetTexture("Interface\\TargetingFrame\\UI-PVP-FFA")
				uf.PvPIcon:Show()			
			elseif UnitFactionGroup(unitId) and UnitIsPVP(unitId) then
				uf.PvPIcon:SetTexture("Interface\\TargetingFrame\\UI-PVP-" .. UnitFactionGroup(unitId))
				uf.PvPIcon:Show()
			else
				uf.PvPIcon:Hide()
			end
		end
	end
end

function BUF_Factory:UpdateCowndown(uf)	
	local unitId = self:GetDisplayUnitId(uf)
	if unitId then
		local needCleanup = false
		for index = 1, uf.debuffCount do
			if not BAF_Factory:UpdateCowndown(uf.Debuffs[index]) then
				needCleanup = true
			end
		end	
		for index = 1, uf.buffCount do
			if not BAF_Factory:UpdateCowndown(uf.Buffs[index]) then
				needCleanup = true
			end 
		end	
		for index = 1, 4 do
			BBB_Factory:UpdateCowndown(uf.BuffBar[index])
		end
		
		if needCleanup then
			self:CleanupUnitAura(uf, true)
		end
	end
end

function BUF_Factory:FastUpdateLife(uf, amount, spellId, incomingHeal)
	if not uf.guiCreated then return end

	local statusMin, statusMax = uf.HealthBar:GetMinMaxValues()
	local oldValue = uf.HealthBar:GetValue()
	local newValue = math.max(0, math.min(statusMax, oldValue)) -- + amount))
	uf.HealthBar:SetValue(newValue)
	
	if (incomingHeal or 0) > 0 then
		uf.incoming = incomingHeal
		uf.IncomingHeal:SetFormattedText("+%.0fk", uf.incoming / 1000)
	end
	if (uf.incoming or 0) > 0 then
		uf.FutureHealthBar:Show()
		uf.FutureHealthBar:SetValue(math.min(statusMax, newValue + uf.incoming))
	else
		uf.FutureHealthBar:Hide()
	end

	if (spellId or 0) > 0 and CSL_Factory:IsOnSpellList(self.SpellWhiteList, spellId) then
		local name, _, icon = GetSpellInfo(spellId)

		if name then
			uf.Spellsymbol:SetTexture(icon)
			uf.Spellsymbol:Show()
			uf.lastSpell = GetTime()
		end
	end
end

function BUF_Factory:ShowSpellsymbol(uf, icon)
	uf.Spellsymbol:SetTexture(icon)
	uf.Spellsymbol:Show()
	uf.lastSpell = GetTime()
end

function BUF_Factory:UpdateUnitAura(uf, event, auraType, debuffType, spellId, caster, count, duration, expirationTime)	
	local unitId = self:GetDisplayUnitId(uf)
	if unitId and UnitIsFriend("player", unitId) then
		local curTemplate = self:GetTemplate(uf.area.Template)
		local index = 1
		local fit = false
				
		if auraType == "BUFF" then	
			if CSL_Factory:IsOnSpellList(self.BuffWhiteList, spellId) then fit = true end
						
			-- Buffs
			if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_AURA_APPLIED_DOSE" or event == "SPELL_AURA_REMOVED_DOSE" then			
				while index <= curTemplate.MaxBuffs and fit and not bUF.checkMode do
					if BAF_Factory:AuraEquals(uf.Buffs[index], spellId, caster) or index > uf.buffCount then
						if index > uf.buffCount then
							uf.buffCount = index
						end						
						BAF_Factory:UpdateAuraFrame(uf.Buffs[index], spellId, caster, count, duration, expirationTime)
						self:UpdateUnitFrame(uf)
						break					
					end
					index = index + 1
				end

				-- Seelensteinauferstehung
				if spellId == 47883 then
					if (expirationTime or 0) > 0 then
						uf.soulstoneExpireTime = expirationTime
					else
						uf.soulstoneExpireTime = GetTime() + 900 -- 15 Min Buffdauer
					end
				end			
				
			elseif event == "SPELL_AURA_REMOVED" then
				while index <= curTemplate.MaxBuffs and fit and not bUF.checkMode do
					if BAF_Factory:AuraEquals(uf.Buffs[index], spellId, caster) then
						for i = index, curTemplate.MaxBuffs - 1 do
							BAF_Factory:CopyAuraFrame(uf.Buffs[i], uf.Buffs[i + 1])
						end					
						BAF_Factory:HideAuraFrame(uf.Buffs[curTemplate.MaxBuffs])
						self:UpdateUnitFrame(uf)
						
						uf.buffCount = uf.buffCount - 1
						break
					end
					index = index + 1
				end
				
				if spellId == 47883 then
					uf.soulstoneExpireTime = GetTime() + 2 -- mal sicherheithalber 2 Sekunden addieren, bis ein evtl. Tod bemerkt wird
				end
			end	
			
			if caster == UnitGUID("player") then
				if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_AURA_APPLIED_DOSE" then
					local buffkey = CSL_Factory:IsOnSpellList(self.PlayerBuffWhiteList, spellId)
					local buffindex = 0 
						
					if buffkey == "buff1" then
						buffindex = 1
					elseif buffkey == "buff2" then
						buffindex = 2
					elseif buffkey == "buff3" then
						buffindex = 3
					elseif buffkey == "buff4" then
						buffindex = 4
					end

					if buffindex > 0 then	
						BBB_Factory:UpdateBuffBar(uf.BuffBar[buffindex], GetTime(), 0, 0)
					end
				end
			end
		else	
			local requireUpdate = false			
			if debuffType then
				requireUpdate = true
			end

			if not CSL_Factory:IsOnSpellList(self.DebuffBlackList, spellId) then		
				-- Debuffs
				if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH" or event == "SPELL_AURA_APPLIED_DOSE" or event == "SPELL_AURA_REMOVED_DOSE" then
					if CSL_Factory:IsOnSpellList(self.EmergencyDebuffList, spellId) then
						uf.numEmergencyDebuff = (uf.numEmergencyDebuff or 0) + 1
						requireUpdate = true
					end
			
					while index <= curTemplate.MaxDebuffs do
						if BAF_Factory:AuraEquals(uf.Debuffs[index], spellId, caster) or index > uf.debuffCount then
							if index > uf.debuffCount then
								uf.debuffCount = index
							end						
							BAF_Factory:UpdateAuraFrame(uf.Debuffs[index], spellId, caster, count, duration, expirationTime)
							break					
						end
						index = index + 1
					end
				elseif event == "SPELL_AURA_REMOVED" then
					if CSL_Factory:IsOnSpellList(self.EmergencyDebuffList, spellId) then
						uf.numEmergencyDebuff = (uf.numEmergencyDebuff or 1) - 1
						requireUpdate = true
					end

					while index <= curTemplate.MaxDebuffs do
						if BAF_Factory:AuraEquals(uf.Debuffs[index], spellId, nil) then
							for i = index, curTemplate.MaxDebuffs - 1 do
								BAF_Factory:CopyAuraFrame(uf.Debuffs[i], uf.Debuffs[i + 1])
							end					
							BAF_Factory:HideAuraFrame(uf.Debuffs[curTemplate.MaxDebuffs])
							uf.debuffCount = uf.debuffCount - 1
							break
						end
						index = index + 1
					end				
				end
			end

			if requireUpdate then
				self:UpdateUnitFrameBarColor(uf)
			end
		end
	end
end

function BUF_Factory:CleanupUnitAura(uf, force)
	local now = GetTime()
	local throttle = false
	if force then throttle = true end
	if uf.lastCleanup < now - 5 then throttle = true end
	
	if uf.unitId and UnitExists(uf.unitId) and throttle and uf.guiCreated then
		uf.lastCleanup = now
		local curTemplate = self:GetTemplate(uf.area.Template)
		local fits
		
		-- Debuffs 
		local infotab = AuraCache:GetInfoTab(UnitGUID(uf.unitId), "DEBUFF")
		
		uf.debuffCount = 0
		uf.numEmergencyDebuff = 0
		if UnitIsFriend("player", uf.unitId) then
			for i = 1, infotab.num do
				local spellId, caster = infotab.spellId[i], infotab.caster[i]
				if CSL_Factory:IsOnSpellList(self.EmergencyDebuffList, spellId) then uf.numEmergencyDebuff = (uf.numEmergencyDebuff or 0) + 1 end
					
				if not CSL_Factory:IsOnSpellList(self.DebuffBlackList, spellId) then
					uf.debuffCount = uf.debuffCount + 1
					if uf.debuffCount > curTemplate.MaxDebuffs then
						uf.debuffCount = curTemplate.MaxDebuffs
						break
					end
					
					BAF_Factory:UpdateAuraFrame(uf.Debuffs[uf.debuffCount], 
						spellId, caster, infotab.count[i], infotab.duration[i], infotab.expirationTime[i]
					)											
				end
			end	
		end	

		for index = uf.debuffCount + 1, curTemplate.MaxDebuffs do
			BAF_Factory:HideAuraFrame(uf.Debuffs[index])	
		end

		for index = 1, 4 do
			if uf.BuffBar[index].timestamp < now - 1 then
				BBB_Factory:HideBuffBar(uf.BuffBar[index])
			end
		end
		
		-- Buffs
		if not bUF.checkMode then
			infotab = AuraCache:GetInfoTab(UnitGUID(uf.unitId), "BUFF")
		
			uf.buffCount = 0
			if UnitIsFriend("player", uf.unitId) then
				for i = 1, infotab.num do
					local spellId, caster = infotab.spellId[i], infotab.caster[i]
									
					fits = false
					if CSL_Factory:IsOnSpellList(self.BuffWhiteList, spellId) then fits = true end
									
					if fits then			
						uf.buffCount = uf.buffCount + 1
						if uf.buffCount > curTemplate.MaxBuffs then
							uf.buffCount = curTemplate.MaxBuffs
							break
						end
					
						BAF_Factory:UpdateAuraFrame(uf.Buffs[uf.buffCount], 
							spellId, caster, infotab.count[i], infotab.duration[i], infotab.expirationTime[i]
						)											
					end

					if caster == UnitGUID("player") then
						local buffkey = CSL_Factory:IsOnSpellList(self.PlayerBuffWhiteList, spellId)
						local buffindex = 0 
						
						if buffkey == "buff1" then
							buffindex = 1
						elseif buffkey == "buff2" then
							buffindex = 2
						elseif buffkey == "buff3" then
							buffindex = 3
						elseif buffkey == "buff4" then
							buffindex = 4
						end

						if buffindex > 0 then	
							BBB_Factory:UpdateBuffBar(uf.BuffBar[buffindex], now, infotab.duration[i], infotab.expirationTime[i])
						end
					end
				end
			end
		
			for index = uf.buffCount + 1, curTemplate.MaxBuffs do
				if uf.Buffs[index] then
					BAF_Factory:HideAuraFrame(uf.Buffs[index])	
				end
			end
		end

		self:UpdateUnitFrame(uf)
	end
end

function BUF_Factory:Show(uf)
	if uf.guiCreated and not uf.shown then
		uf.BaseFrame:Show()
		RegisterUnitWatch(uf.BaseFrame)
		self:UpdateUnitFrameComplete(uf)
		uf.shown = true
	end
end

function BUF_Factory:Hide(uf)
	if uf.guiCreated and uf.shown then
		uf.BaseFrame:Hide()
		UnregisterUnitWatch(uf.BaseFrame)
		uf.shown = false
	end
end
